<?php
class UpdatedEvCheckoutOrdersTable extends CakeMigration {

/**
 * Migration description
 *
 * @var string
 */
	public $description = '';

/**
 * Actions to be performed
 *
 * @var array $migration
 */
	public $migration = array(
		'up' => array(
			'alter_field' => array(
				'ev_checkout_customer_addresses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'user_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'index'),
				),
				'ev_checkout_order_items' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'order_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'model_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'vat_rate_id' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'unit_cost' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2', 'unsigned' => false),
					'quantity' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'subtotal' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2', 'unsigned' => false),
					'vat' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2', 'unsigned' => false),
					'total' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2', 'unsigned' => false),
				),
				'ev_checkout_order_statuses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
				),
				'ev_checkout_orders' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'order_time' => array('type' => 'datetime', 'null' => false, 'default' => null),
					'user_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'processed_by' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'delivery_address_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'invoice_address_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'order_status_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'subtotal' => array('type' => 'decimal', 'null' => false, 'default' => null, 'length' => '7,2', 'unsigned' => false),
					'delivery_subtotal' => array('type' => 'decimal', 'null' => false, 'default' => '0.00', 'length' => '7,2', 'unsigned' => false),
					'delivery_vat' => array('type' => 'decimal', 'null' => false, 'default' => '0.00', 'length' => '7,2', 'unsigned' => false),
					'surcharge_subtotal' => array('type' => 'decimal', 'null' => false, 'default' => '0.00', 'length' => '7,2', 'unsigned' => false),
					'surcharge_vat' => array('type' => 'decimal', 'null' => false, 'default' => '0.00', 'length' => '7,2', 'unsigned' => false),
					'delivery_total' => array('type' => 'decimal', 'null' => false, 'default' => '0.00', 'length' => '7,2', 'unsigned' => false),
					'surcharge_total' => array('type' => 'decimal', 'null' => false, 'default' => '0.00', 'length' => '7,2', 'unsigned' => false),
					'vat' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2', 'unsigned' => false),
					'total' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2', 'unsigned' => false),
					'items_total' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
				),
				'ev_checkout_vat_rates' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'rate' => array('type' => 'float', 'null' => true, 'default' => null, 'unsigned' => false),
				),
			),
		),
		'down' => array(
			'alter_field' => array(
				'ev_checkout_customer_addresses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'user_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'index'),
				),
				'ev_checkout_order_items' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'order_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'model_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'vat_rate_id' => array('type' => 'integer', 'null' => true, 'default' => null),
					'unit_cost' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'quantity' => array('type' => 'integer', 'null' => false, 'default' => null),
					'subtotal' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'vat' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'total' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
				),
				'ev_checkout_order_statuses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
				),
				'ev_checkout_orders' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'order_time' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'user_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'processed_by' => array('type' => 'string', 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'delivery_address_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'invoice_address_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'order_status_id' => array('type' => 'integer', 'null' => false, 'default' => null),
					'subtotal' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'delivery_subtotal' => array('type' => 'float', 'null' => false, 'default' => '0.00', 'length' => '7,2'),
					'delivery_vat' => array('type' => 'float', 'null' => false, 'default' => '0.00', 'length' => '7,2'),
					'delivery_total' => array('type' => 'float', 'null' => false, 'default' => '0.00', 'length' => '7,2'),
					'surcharge_subtotal' => array('type' => 'float', 'null' => false, 'default' => '0.00', 'length' => '7,2'),
					'surcharge_vat' => array('type' => 'float', 'null' => false, 'default' => '0.00', 'length' => '7,2'),
					'surcharge_total' => array('type' => 'float', 'null' => false, 'default' => '0.00', 'length' => '7,2'),
					'vat' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'total' => array('type' => 'float', 'null' => false, 'default' => null, 'length' => '7,2'),
					'items_total' => array('type' => 'integer', 'null' => false, 'default' => null),
				),
				'ev_checkout_vat_rates' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'rate' => array('type' => 'float', 'null' => true, 'default' => null),
				),
			),
		),
	);

/**
 * Before migration callback
 *
 * @param string $direction, up or down direction of migration process
 * @return boolean Should process continue
 */
	public function before($direction) {
		return true;
	}

/**
 * After migration callback
 *
 * @param string $direction, up or down direction of migration process
 * @return boolean Should process continue
 */
	public function after($direction) {
		return true;
	}
}
